package org.apache.commons.math.geometry;

import static org.junit.Assert.*;

import org.junit.Test;

public class OrthogonalCumulativeTest_junit {

	@Test
	public void test1BranchAdeqTs1() {
		try {
			Vector3D vector1 = new Vector3D(0.1, 0.2, 0.3);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 0.8320502943378436, 0.0);
			assertEquals(resultVector.getZ(), -0.5547001962252291, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}

	}

	@Test
	public void test2BranchAdeqTs1() {
		try {
			Vector3D vector1 = new Vector3D();
			Vector3D resultVector = vector1.orthogonal();
			fail("null norm exeption should be thrown");
		} catch (Exception ex) {
			assertEquals(ex.getMessage(), "null norm");
		}

	}

	@Test
	public void test3BranchAdeqTs1() {
		try {
			Vector3D vector1 = new Vector3D(0.2, 0.2, 0.0);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.7071067811865475, 0.0);
			assertEquals(resultVector.getY(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test4BranchAdeqTs1() {
		try {
			Vector3D vector1 = new Vector3D(-0.3, 0.2, 0.1);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.31622776601683794, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -0.9486832980505137, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}

	}

	@Test
	public void test5BranchAdeqTs1() {
		try {
			Vector3D vector1 = new Vector3D(0.2, -0.2, 0.15);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getY(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}

	}

	@Test
	public void test1BranchAdeqTs2() {
		try {
			Vector3D vector1 = new Vector3D(1.0, 2.3, 4.3);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 0.8817846419346916, 0.0);
			assertEquals(resultVector.getZ(), -0.47165225033716063, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}

	}

	@Test
	public void test2BranchAdeqTs2() {
		try {
			Vector3D vector1 = new Vector3D(0.0, 0.0, 0.0);
			Vector3D resultVector = vector1.orthogonal();
			fail("null norm exeption should be thrown");
		} catch (Exception ex) {
			assertEquals(ex.getMessage(), "null norm");
		}
	}

	@Test
	public void test3BranchAdeqTs2() {
		try {
			Vector3D vector1 = new Vector3D(-4.3, -2.3, 1.0);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.2265134946602783, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -0.9740080270391966, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test4BranchAdeqTs2() {
		try {

			Vector3D vector1 = new Vector3D(9.4, 9.1, 0.3);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.6955487380269249, 0.0);
			assertEquals(resultVector.getY(), -0.7184789162036367, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test5BranchAdeqTs2() {
		try {

			Vector3D vector1 = new Vector3D(7.4, -9.1, 2.3);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7758531427722155, 0.0);
			assertEquals(resultVector.getY(), -0.6309135446719116, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test1BranchAdeqTs3() {
		try {
			Vector3D vector1 = new Vector3D(10.0, 20.3, 40.3);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 0.8930935697401533, 0.0);
			assertEquals(resultVector.getZ(), -0.44987095448449416, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test2BranchAdeqTs3() {
		try {
			Vector3D vector1 = new Vector3D(0.0, 0.0, 0.0);
			Vector3D resultVector = vector1.orthogonal();
			fail("null norm exeption should be thrown");
		} catch (Exception ex) {
			assertEquals(ex.getMessage(), "null norm");
		}

	}

	@Test
	public void test3BranchAdeqTs3() {
		try {
			Vector3D vector1 = new Vector3D(-27.3, 10.3, 30.0);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7396053187813131, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -0.673040840090995, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test4BranchAdeqTs3() {
		try {
			Vector3D vector1 = new Vector3D(27.3, 30.1, 0.3);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.7407190347407712, 0.0);
			assertEquals(resultVector.getY(), -0.6718149384858156, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test5BranchAdeqTs3() {
		try {

			Vector3D vector1 = new Vector3D(27.4, -30.1, 20.3);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7394952429779589, 0.0);
			assertEquals(resultVector.getY(), -0.6731617826443878, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test1BranchAdeqTs4() {
		try {

			Vector3D vector1 = new Vector3D(0.01, 0.04, 0.3);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 0.9912279006826347, 0.0);
			assertEquals(resultVector.getZ(), -0.13216372009101796, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}

	}

	@Test
	public void test2BranchAdeqTs4() {
		try {
			Vector3D vector1 = new Vector3D();
			Vector3D resultVector = vector1.orthogonal();
			fail("null norm exeption should be thrown");
		} catch (Exception ex) {
			assertEquals(ex.getMessage(), "null norm");
		}

	}

	@Test
	public void test3BranchAdeqTs4() {
		try {

			Vector3D vector1 = new Vector3D(-0.03, -0.03, 0.01);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getY(), 0.7071067811865475, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test4BranchAdeqTs4() {
		try {

			Vector3D vector1 = new Vector3D(0.03, 0.01, 0.03);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 0.7071067811865475, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test5BranchAdeqTs4() {
		try {

			Vector3D vector1 = new Vector3D(0.092, 0.1, 0.053);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.7359310117618297, 0.0);
			assertEquals(resultVector.getY(), -0.6770565308208834, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test1BranchAdeqTs5() {
		Vector3D v3d = new Vector3D(0, 0, 0);
		try {
			Vector3D orth = v3d.orthogonal();
			fail("null norm exeption should be thrown");
		} catch (Exception e) {
			assertEquals(e.getMessage(), "null norm");
		}
	}

	@Test
	public void test2BranchAdeqTs5() {
		Vector3D v3d = new Vector3D(1, 2, 3);
		try {
			Vector3D orth = v3d.orthogonal();
			assertEquals(orth.getX(), 0.0, 0.0);
			assertEquals(orth.getY(), 0.8320502943378437, 0.0);
			assertEquals(orth.getZ(), -0.5547001962252291, 0.0);
		} catch (Exception e) {
			fail(e.getMessage());
		}
	}

	@Test
	public void test3BranchAdeqTs5() {
		Vector3D v3d = new Vector3D(-1, 1, 0);
		try {
			Vector3D orth = v3d.orthogonal();
			assertEquals(orth.getX(), 0.7071067811865475, 0.0);
			assertEquals(orth.getY(), 0.7071067811865475, 0.0);
			assertEquals(orth.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail(e.getMessage());
		}
	}

	@Test
	public void test4BranchAdeqTs5() {
		Vector3D v3d = new Vector3D(1, 0, 0);
		try {
			Vector3D orth = v3d.orthogonal();
			assertEquals(orth.getX(), -0.0, 0.0);
			assertEquals(orth.getY(), 0.0, 0.0);
			assertEquals(orth.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail(e.getMessage());
		}
	}

	@Test
	public void test5BranchAdeqTs5() {
		Vector3D v3d = new Vector3D(1.0, -1.0, 0.15);
		try {
			Vector3D orth = v3d.orthogonal();
			assertEquals(orth.getX(), -0.7071067811865475, 0.0);
			assertEquals(orth.getY(), -0.7071067811865475, 0.0);
			assertEquals(orth.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}

	}

	@Test
	public void test2MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D();
			Vector3D resultVector = vector1.orthogonal();
			fail("null norm exeption should be thrown");
		} catch (Exception ex) {
			assertEquals(ex.getMessage(), "null norm");
		}
	}

	@Test
	public void test3MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D(0.3, 0.2, 0.1);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.31622776601683794, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 0.9486832980505137, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test4MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D(-0.2, 0.2, 0.1);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.7071067811865475, 0.0);
			assertEquals(resultVector.getY(), 0.7071067811865475, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test5MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D(0.2, -0.2, 0.0);
			Vector3D resultVector = vector1.orthogonal();

			assertEquals(resultVector.getX(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getY(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test6MutationAdeqTs_Major() {
		try {
			Vector3D v5 = new Vector3D(1.2, 0, -1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), -1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test7MutationAdeqTs_Major() {
		try {
			Vector3D v8 = new Vector3D(0.8, -0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test8MutationAdeqTs_Major() {
		try {
			Vector3D v7 = new Vector3D(-0.6, 0.8, 0);
			Vector3D resultVector = v7.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test9MutationAdeqTs_Major() {
		try {
			Vector3D v8 = new Vector3D(-0.8, 0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test1MutationAdeqTs_mujava() {
		Vector3D orth = null;
		Vector3D v3d = new Vector3D(0, 0, 0);
		boolean test = false;
		try {
			orth = v3d.orthogonal();
		} catch (ArithmeticException e) {
			test = true;
		}
		assertTrue(test);
	}

	@Test
	public void test2MutationAdeqTs_mujava() {
		Vector3D v3d = new Vector3D(1, 1, 1);
		Vector3D orth = v3d.orthogonal();
		assertTrue(orth.getX() == 0 && orth.getY() == 0.7071067811865475 && orth.getZ() == -0.7071067811865475);
	}

	@Test
	public void test3MutationAdeqTs_mujava() {
		Vector3D v3d = new Vector3D(0.5, 0.3, 0.1);
		Vector3D orth = v3d.orthogonal();
		assertTrue(orth.getX() == -0.19611613513818404 && orth.getY() == 0 && orth.getZ() == 0.9805806756909201);
	}

	@Test
	public void test4MutationAdeqTs_mujava() {
		Vector3D v3d = new Vector3D(1, 1, 0);
		Vector3D orth = v3d.orthogonal();
		assertTrue(orth.getX() == 0.7071067811865475 && orth.getY() == -0.7071067811865475 && orth.getZ() == 0);
	}

	@Test
	public void test5MutationAdeqTs_mujava() {
		try {
			Vector3D v5 = new Vector3D(1.2, 0, -1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), -1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test6MutationAdeqTs_mujava() {
		try {
			Vector3D v8 = new Vector3D(0.8, -0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test7MutationAdeqTs_mujava() {
		try {
			Vector3D v8 = new Vector3D(-0.8, 0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(String.valueOf(resultVector.getX()), "-0.0");
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test8MutationAdeqTs_mujava() {
		try {
			Vector3D vector1 = new Vector3D(0.3, -0.3, 0.15);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7071067811865476, 0.0);
			assertEquals(resultVector.getY(), -0.7071067811865476, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test9MutationAdeqTs_mujava() {
		try {
			Vector3D v5 = new Vector3D(-1.2, 0, -1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), -1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test1MutationAdeqTs_PitAll() {
		try {
			Vector3D v3 = new Vector3D(-1.7, 1.4, 0.2);
			Vector3D resultVector = v3.orthogonal();
			assertEquals(resultVector.getX(), 0.6357072528610996, 0.0);
			assertEquals(resultVector.getY(), 0.7719302356170497, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test2MutationAdeqTs_PitAll() {
		try {
			Vector3D v7 = new Vector3D(0.6, 0.8, 0);
			Vector3D resultVector = v7.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test3MutationAdeqTs_PitAll() {
		try {
			Vector3D v8 = new Vector3D(0.8, 0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test4MutationAdeqTs_PitAll() {
		try {
			Vector3D v10 = new Vector3D(1.2, 0.8, 0.8);
			Vector3D resultVector = v10.orthogonal();
			assertEquals(resultVector.getX(), -0.5547001962252291, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 0.8320502943378436, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test5MutationAdeqTs_PitAll() {
		try {
			new Vector3D(0, 0, 0).orthogonal();
			fail("an exception should have been thrown");
		} catch (ArithmeticException ae) {
			assertEquals(ae.getMessage(), "null norm");
			// expected behavior
		} catch (Exception e) {
			fail("wrong exception caught: " + e.getMessage());
		}

	}

	@Test
	public void test6MutationAdeqTs_PitAll() {
		try {
			Vector3D vector1 = new Vector3D(0.3, -0.3, 0.15);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7071067811865476, 0.0);
			assertEquals(resultVector.getY(), -0.7071067811865476, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test7MutationAdeqTs_PitAll() {
		try {
			Vector3D v5 = new Vector3D(-1.2, 0, 1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test8MutationAdeqTs_PitAll() {
		try {
			Vector3D v8 = new Vector3D(0.8, -0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}
}
