package org.apache.commons.math.geometry;

import static org.junit.Assert.*;

import org.junit.Test;

public class OrthogonalMutationAdeqTests_junitformat {

	@Test
	public void test2MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D();
			Vector3D resultVector = vector1.orthogonal();
			fail("null norm exeption should be thrown");
		} catch (Exception ex) {
			assertEquals(ex.getMessage(), "null norm");
		}
	}

	@Test
	public void test3MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D(0.3, 0.2, 0.1);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.31622776601683794, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 0.9486832980505137, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test4MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D(-0.2, 0.2, 0.1);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.7071067811865475, 0.0);
			assertEquals(resultVector.getY(), 0.7071067811865475, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test5MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D(0.2, -0.2, 0.0);
			Vector3D resultVector = vector1.orthogonal();

			assertEquals(resultVector.getX(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getY(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test6MutationAdeqTs_Major() {
		try {
			Vector3D v5 = new Vector3D(1.2, 0, -1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), -1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test7MutationAdeqTs_Major() {
		try {
			Vector3D v8 = new Vector3D(0.8, -0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test8MutationAdeqTs_Major() {
		try {
			Vector3D v7 = new Vector3D(-0.6, 0.8, 0);
			Vector3D resultVector = v7.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test9MutationAdeqTs_Major() {
		try {
			Vector3D v8 = new Vector3D(-0.8, 0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test1MutationAdeqTs_mujava() {
		Vector3D orth = null;
		Vector3D v3d = new Vector3D(0, 0, 0);
		boolean test = false;
		try {
			orth = v3d.orthogonal();
		} catch (ArithmeticException e) {
			test = true;
		}
		assertTrue(test);
	}

	@Test
	public void test2MutationAdeqTs_mujava() {
		Vector3D v3d = new Vector3D(1, 1, 1);
		Vector3D orth = v3d.orthogonal();
		assertTrue(orth.getX() == 0 && orth.getY() == 0.7071067811865475 && orth.getZ() == -0.7071067811865475);
	}

	@Test
	public void test3MutationAdeqTs_mujava() {
		Vector3D v3d = new Vector3D(0.5, 0.3, 0.1);
		Vector3D orth = v3d.orthogonal();
		assertTrue(orth.getX() == -0.19611613513818404 && orth.getY() == 0 && orth.getZ() == 0.9805806756909201);
	}

	@Test
	public void test4MutationAdeqTs_mujava() {
		Vector3D v3d = new Vector3D(1, 1, 0);
		Vector3D orth = v3d.orthogonal();
		assertTrue(orth.getX() == 0.7071067811865475 && orth.getY() == -0.7071067811865475 && orth.getZ() == 0);
	}

	@Test
	public void test5MutationAdeqTs_mujava() {
		try {
			Vector3D v5 = new Vector3D(1.2, 0, -1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), -1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test6MutationAdeqTs_mujava() {
		try {
			Vector3D v8 = new Vector3D(0.8, -0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test7MutationAdeqTs_mujava() {
		try {
			Vector3D v8 = new Vector3D(-0.8, 0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(String.valueOf(resultVector.getX()), "-0.0");
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test8MutationAdeqTs_mujava() {
		try {
			Vector3D vector1 = new Vector3D(0.3, -0.3, 0.15);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7071067811865476, 0.0);
			assertEquals(resultVector.getY(), -0.7071067811865476, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test9MutationAdeqTs_mujava() {
		try {
			Vector3D v5 = new Vector3D(-1.2, 0, -1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), -1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test1MutationAdeqTs_PitAll() {
		try {
			Vector3D v3 = new Vector3D(-1.7, 1.4, 0.2);
			Vector3D resultVector = v3.orthogonal();
			assertEquals(resultVector.getX(), 0.6357072528610996, 0.0);
			assertEquals(resultVector.getY(), 0.7719302356170497, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test2MutationAdeqTs_PitAll() {
		try {
			Vector3D v7 = new Vector3D(0.6, 0.8, 0);
			Vector3D resultVector = v7.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test3MutationAdeqTs_PitAll() {
		try {
			Vector3D v8 = new Vector3D(0.8, 0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test4MutationAdeqTs_PitAll() {
		try {
			Vector3D v10 = new Vector3D(1.2, 0.8, 0.8);
			Vector3D resultVector = v10.orthogonal();
			assertEquals(resultVector.getX(), -0.5547001962252291, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 0.8320502943378436, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test5MutationAdeqTs_PitAll() {
		try {
			new Vector3D(0, 0, 0).orthogonal();
			fail("an exception should have been thrown");
		} catch (ArithmeticException ae) {
			assertEquals(ae.getMessage(), "null norm");
			// expected behavior
		} catch (Exception e) {
			fail("wrong exception caught: " + e.getMessage());
		}

	}

	@Test
	public void test6MutationAdeqTs_PitAll() {
		try {
			Vector3D vector1 = new Vector3D(0.3, -0.3, 0.15);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7071067811865476, 0.0);
			assertEquals(resultVector.getY(), -0.7071067811865476, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test7MutationAdeqTs_PitAll() {
		try {
			Vector3D v5 = new Vector3D(-1.2, 0, 1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test8MutationAdeqTs_PitAll() {
		try {
			Vector3D v8 = new Vector3D(0.8, -0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}
}
