package org.apache.commons.math.geometry;

import static org.junit.Assert.*;

import org.junit.Test;

public class OrthogonalMutationAdeqTs_Major {

	@Test
	public void test2MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D();
			Vector3D resultVector = vector1.orthogonal();
			fail("null norm exeption should be thrown");
		} catch (Exception ex) {
			assertEquals(ex.getMessage(), "null norm");
		}
	}

	@Test
	public void test3MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D(0.3, 0.2, 0.1);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.31622776601683794, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 0.9486832980505137, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test4MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D(-0.2, 0.2, 0.1);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), 0.7071067811865475, 0.0);
			assertEquals(resultVector.getY(), 0.7071067811865475, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test5MutationAdeqTs_Major() {
		try {
			Vector3D vector1 = new Vector3D(0.2, -0.2, 0.0);
			Vector3D resultVector = vector1.orthogonal();

			assertEquals(resultVector.getX(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getY(), -0.7071067811865475, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test6MutationAdeqTs_Major() {
		try {
			Vector3D v5 = new Vector3D(1.2, 0, -1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), -1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	
	@Test
	public void test7MutationAdeqTs_Major() {
		try {
			Vector3D v8 = new Vector3D(0.8, -0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}
	
	
	@Test
	public void test8MutationAdeqTs_Major() {
		try {
			Vector3D v7 = new Vector3D(-0.6, 0.8, 0);
			Vector3D resultVector = v7.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}
	
	
	@Test
	public void test9MutationAdeqTs_Major() {
		try {
			Vector3D v8 = new Vector3D(-0.8, 0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}
	
}
