package org.apache.commons.math.geometry;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import org.junit.Test;

public class OrthogonalMutationAdeqTs_mujava_junitformat {

	@Test
	public void test1MutationAdeqTs_mujava() {
		Vector3D orth = null;
		Vector3D v3d = new Vector3D(0, 0, 0);
		boolean test = false;
		try {
			orth = v3d.orthogonal();
		} catch (ArithmeticException e) {
			test = true;
		}
		assertTrue(test);
	}

	@Test
	public void test2MutationAdeqTs_mujava() {
		Vector3D v3d = new Vector3D(1, 1, 1);
		Vector3D orth = v3d.orthogonal();
		assertTrue(orth.getX() == 0 && orth.getY() == 0.7071067811865475 && orth.getZ() == -0.7071067811865475);
	}

	@Test
	public void test3MutationAdeqTs_mujava() {
		Vector3D v3d = new Vector3D(0.5, 0.3, 0.1);
		Vector3D orth = v3d.orthogonal();
		assertTrue(orth.getX() == -0.19611613513818404 && orth.getY() == 0 && orth.getZ() == 0.9805806756909201);
	}

	@Test
	public void test4MutationAdeqTs_mujava() {
		Vector3D v3d = new Vector3D(1, 1, 0);
		Vector3D orth = v3d.orthogonal();
		assertTrue(orth.getX() == 0.7071067811865475 && orth.getY() == -0.7071067811865475 && orth.getZ() == 0);
	}

	@Test
	public void test5MutationAdeqTs_mujava() {
		try {
			Vector3D v5 = new Vector3D(1.2, 0, -1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), -1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test6MutationAdeqTs_mujava() {
		try {
			Vector3D v8 = new Vector3D(0.8, -0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), 1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test7MutationAdeqTs_mujava() {
		try {
			Vector3D v8 = new Vector3D(-0.8, 0.6, 0);
			Vector3D resultVector = v8.orthogonal();
			assertEquals(resultVector.getX(), -0.0, 0.0);
			assertEquals(String.valueOf(resultVector.getX()), "-0.0");
			assertEquals(resultVector.getY(), 0.0, 0.0);
			assertEquals(resultVector.getZ(), -1.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test8MutationAdeqTs_mujava() {
		try {
			Vector3D vector1 = new Vector3D(0.3, -0.3, 0.15);
			Vector3D resultVector = vector1.orthogonal();
			assertEquals(resultVector.getX(), -0.7071067811865476, 0.0);
			assertEquals(resultVector.getY(), -0.7071067811865476, 0.0);
			assertEquals(resultVector.getZ(), 0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}

	@Test
	public void test9MutationAdeqTs_mujava() {
		try {
			Vector3D v5 = new Vector3D(-1.2, 0, -1.6);
			Vector3D resultVector = v5.orthogonal();
			assertEquals(resultVector.getX(), 0.0, 0.0);
			assertEquals(resultVector.getY(), -1.0, 0.0);
			assertEquals(resultVector.getZ(), -0.0, 0.0);
		} catch (Exception e) {
			fail("exception thrown");
		}
	}
}
