package org.apache.commons.math.util;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class gcdCumulativeTests_junitformat {

	@Test
	public void test1BranchAdeqTs1() {
		int u = 0;
		int v = 0;

		assertTrue(MathUtils.gcd(u, v) == 0);
	}

	@Test
	public void test2BranchAdeqTs1() {
		int u = 50;
		int v = 50;

		assertTrue(MathUtils.gcd(u, v) == 50);
	}

	@Test
	public void test3BranchAdeqTs1() {
		int u = -49;
		int v = 50;

		assertTrue(MathUtils.gcd(u, v) == 1);
	}

	@Test
	public void test4BranchAdeqTs1() {
		int u = 50;
		int v = -49;

		assertTrue(MathUtils.gcd(u, v) == 1);
	}

	@Test
	public void test1BranchAdeqTs2() {
		assertEquals(MathUtils.gcd(-5, 0), 5);

	}

	@Test
	public void test3BranchAdeqTs2() {
		assertEquals(MathUtils.gcd((int) Math.pow(2, 30), 6), 2);
	}

	@Test
	public void test5BranchAdeqTs2() {
		assertEquals(MathUtils.gcd(-2, -6), 2);
	}

	@Test
	public void test1BranchAdeqTs3() {
		int u = 474747;
		int v = 4577770;

		assertEquals((MathUtils.gcd(u, v)), 1);

	}

	@Test
	public void test2BranchAdeqTs3() {
		int u = -6436;
		int v = 333;

		assertEquals((MathUtils.gcd(u, v)), 1);
	}

	@Test
	public void test3BranchAdeqTs3() {
		int u = 1346346336;
		int v = -1366663636;

		assertEquals((MathUtils.gcd(u, v)), 4);
	}

	@Test
	public void test4BranchAdeqTs3() {
		int u = 0;
		int v = 4747474;

		assertEquals((MathUtils.gcd(u, v)), 4747474);
	}

	@Test
	public void test1BranchAdeqTs4() {
		int u = -5232782;
		int v = -772222;

		assertEquals((MathUtils.gcd(u, v)), 2);

	}

	@Test
	public void test2BranchAdeqTs4() {
		int u = 6;
		int v = 3;

		assertEquals((MathUtils.gcd(u, v)), 3);
	}

	@Test
	public void test3BranchAdeqTs4() {
		int u = 0;
		int v = -0;

		assertEquals((MathUtils.gcd(u, v)), 0);
	}

	@Test
	public void test1BranchAdeqTs5() {
		int u = -66743;
		int v = 56566;

		assertEquals((MathUtils.gcd(u, v)), 1);

	}

	@Test
	public void test2BranchAdeqTs5() {
		int u = 464;
		int v = -4747;

		assertEquals((MathUtils.gcd(u, v)), 1);
	}

	@Test
	public void test3BranchAdeqTs5() {
		int u = 555555;
		int v = 0;

		assertEquals((MathUtils.gcd(u, v)), 555555);
	}

	@Test
	public void test4BranchAdeqTs5() {
		int u = 546366;
		int v = 47478;

		assertEquals((MathUtils.gcd(u, v)), 246);
	}

	@Test
	public void test1Major() {
		MathUtils utilOne = null;
		int intOne = utilOne.gcd(-30, -20);
		assertEquals(intOne, 10);
	}

	@Test
	public void test2Major() {
		MathUtils utilOne = null;
		int intOne = utilOne.gcd(-1073741824, -1073741824);
		assertEquals(intOne, -2147483648);
	}

	@Test
	public void test4Major() {
		MathUtils utilOne = null;
		int intOne = utilOne.gcd(1, 1);
		assertEquals(intOne, 1);
	}

	@Test
	public void test5Major() {
		MathUtils utilOne = null;
		int intOne = utilOne.gcd(20, 30);
		assertEquals(intOne, 10);
	}

	@Test
	public void test7Major() {
		MathUtils utilOne = null;
		int intOne = utilOne.gcd(9, (int) Math.pow(2, 34));
		assertEquals(intOne, 1);
	}

	@Test
	public void test8Major() {
		MathUtils utilOne = null;
		int intOne = utilOne.gcd(-1396321570, -789606905);
		assertEquals(intOne, 5);
	}

	@Test
	public void test2_mujava() {

		int u = 50;
		int v = 50;

		assertEquals((MathUtils.gcd(u, v)), 50);
	}

	@Test
	public void test4_mujava() {

		int u = 50;
		int v = -49;

		assertEquals((MathUtils.gcd(u, v)), 1);
	}

	@Test
	public void test6_mujava() {

		int u = 65536;
		int v = 65536;

		assertEquals((MathUtils.gcd(u, v)), 131072);
	}

	@Test
	public void test8_mujava() {

		int u = 4;
		int v = 32;

		assertEquals((MathUtils.gcd(u, v)), 4);
	}

	@Test
	public void test9_mujava() {

		int u = 32;
		int v = 4;

		assertEquals((MathUtils.gcd(u, v)), 4);
	}

	@Test
	public void test10_mujava() {

		assertEquals(MathUtils.gcd((int) Math.pow(2, 39), 3), 1);

	}

	@Test
	public void test11_mujava() {

		assertEquals(MathUtils.gcd(-1228437670, -528239105), 5);

	}

	@Test
	public void test1PITAll() {
		int expected = 5;
		assertEquals(expected, MathUtils.gcd(-5, 0));
	}

	@Test
	public void test4PITAll() {
		int expected = 2;
		assertEquals(expected, MathUtils.gcd((int) Math.pow(2, 30), 6));
	}

	@Test
	public void test5PITAll() {
		int expected = 2;
		assertEquals(expected, MathUtils.gcd(6, (int) Math.pow(2, 30)));
	}

	@Test
	public void test6PITAll() {
		int expected = 1;
		assertEquals(expected, MathUtils.gcd((int) Math.pow(2, 33), 6));
	}

	// edw
	@Test
	public void test8PITAll() {
		int expected = -2147483646;
		assertEquals(expected, MathUtils.gcd((int) Math.pow(-2, 33), -2));
	}

	@Test
	public void test9PITAll() {
		int expected = 2;
		assertEquals(expected, MathUtils.gcd(-2, -6));
	}

	@Test
	public void test11PITAll() {
		int expected = 5;
		assertEquals(expected, MathUtils.gcd(-1091314270, -531525255));
	}
}
